Issue289

Title Disjunctive landmarks creation is buggy
Priority bug Status resolved
Superseder Nosy List erez, gabi, malte, salome, silvan, silvia
Assigned To gabi Keywords
Optional summary

Created on 2011-10-19.21:27:01 by silvia, last changed by gabi.

Files
File name Uploaded Type Edit Remove
example_problem.tar.gz salome, 2013-06-21.15:40:44 application/x-gzip
Messages
msg5007 (view) Author: gabi Date: 2016-01-04.17:30:29
We have decided that we can live without experimental results.
msg3387 (view) Author: gabi Date: 2014-08-29.15:23:53
If I see this correctly, this issue has already been resolved and merged a long
time ago. It is only still open because nobody ran the final experiments, right?
I just started them...
msg2502 (view) Author: malte Date: 2013-06-24.17:37:25
Given the nastiness of the landmark code, I think it'd be good to see a
before/after experiment for all LM generation changes. The two configurations
I'd suggest checking are:

- ipc seq-sat-lama-2011 on all tasks
- ipc seq-opt-bjolp on all optimal tasks without axioms/conditional effects
msg2501 (view) Author: gabi Date: 2013-06-24.12:11:30
This issue is now resolved. I split up the part with creating disjunctive
landmarks along variables instead of predicate names (issue384).
msg2497 (view) Author: salome Date: 2013-06-21.15:40:44
An example problem to test the implementation
msg2436 (view) Author: gabi Date: 2013-05-15.14:00:40
Salomé is going to look into this. Silvan, since you refactored the LM code some
time ago, it would be good if we could briefly discuss how this should be fixed
the best way.
msg1830 (view) Author: malte Date: 2011-10-19.21:44:44
Who can look into this?
msg1829 (view) Author: malte Date: 2011-10-19.21:44:33
Adding Silvan who is working on refactoring the landmark code.

Do you know a concrete example where the problem occurs? That would be helpful
for debugging.

After we fix this, I suggest that we also look at different ways of restricting
which disjunctive landmarks to allow rather than looking at predicate names.
Using predicate names always looked like a bit of a hack to me, since the search
component of the planner is otherwise based on the finite-domain representation
of the planner, which has no such thing. I'd like to see what happens if we look
at other criteria instead, e.g. only allowing disjunctive landmarks where all
facts refer to the same finite-domain variable.
msg1828 (view) Author: silvia Date: 2011-10-19.21:27:00
Bug reported by Maryam.

Concerns the method in which we compute disjunctive
preconditions("compute_disjunctive_preconditions" in class "LandmarksGraphNew").

We construct a hash_map ("preconditions") that maps predicates to a list of
propositions, where that list of propositions contains all preconditions with
the given predicate of operators that possibly achieve the given landmark.
At the end of method the following happens: for each entry of "preconditions",
if the size of the associated list of propositions is equal to the number of
operators, it is accepted as a disjunctive landmark.

This may lead to problems: some operators may have more than one precondition
with the same predicate (for example operator "lift" in domain "Depot"). In such
cases, this method may create some set of propositions as a disjunctive landmark
which does not contain one precondition fact from each of the operators (e.g. if
some operator has more than on precondition with this predicate and another
operator has no precondition with this predicate). The method may also fail to
construct some possible disjunctive landmarks.
History
Date User Action Args
2016-01-04 17:30:29gabisetstatus: testing -> resolved
messages: + msg5007
2014-08-29 15:23:53gabisetstatus: chatting -> testing
assignedto: gabi
messages: + msg3387
2013-06-24 17:37:25maltesetstatus: resolved -> chatting
messages: + msg2502
2013-06-24 12:11:30gabisetstatus: chatting -> resolved
assignedto: salome -> (no value)
messages: + msg2501
2013-06-24 12:09:41gabilinkissue384 superseder
2013-06-21 15:40:44salomesetfiles: + example_problem.tar.gz
messages: + msg2497
2013-05-15 14:00:40gabisetassignedto: salome
messages: + msg2436
nosy: + gabi, salome
2011-10-19 21:44:44maltesetmessages: + msg1830
2011-10-19 21:44:33maltesetnosy: + silvan
messages: + msg1829
2011-10-19 21:27:01silviacreate